import { C as i } from "./constants-82SkCe1P.js";
import { d as l } from "./date-utils-LPKtZBIf.js";
class M {
  DEFAULT_PAGINATION_OPTIONS() {
    return { Offset: 0, Limit: 20, Order: "id", Sort: "asc" };
  }
  getTotalRowsFromResponseHeader(t) {
    var r;
    const e = t.headers["content-range"];
    if (!e)
      return t.data.length;
    const n = parseInt((r = e.split("/")) == null ? void 0 : r[1], 10);
    return isNaN(n) ? t.data.length : n;
  }
  getPaginationString(t) {
    return t ? `?limit=${t.Limit}&offset=${t.Offset}&order=${t.Order}.${t.Sort}` : null;
  }
}
const P = new M();
function O(v) {
  if (v === null || typeof v != "object")
    return !1;
  const t = Object.keys(v);
  return t.includes("operator") && t.includes("constraints");
}
const d = "global";
class N {
  getConstraintSearchQuery(t, e, n = "=") {
    switch (e.matchMode) {
      case "startsWith":
        return `${t}${n}ilike.${e.value}*`;
      case "contains":
        return `${t}${n}ilike.*${e.value}*`;
      case "notContains":
        return `${t}${n}not.ilike.*${e.value}*`;
      case "endsWith":
        return `${t}${n}ilike.*${e.value}`;
      case "equals":
        return `${t}${n}eq.${e.value}`;
      case "notEquals":
        return `${t}${n}not.eq.${e.value}`;
      case "in":
        return `${t}${n}cs.{${e.value.map((r) => `"${r}"`).join(",")}}`;
      case "lt":
        return `${t}${n}lt.${e.value}`;
      case "lte":
        return `${t}${n}lte.${e.value}`;
      case "gt":
        return `${t}${n}gt.${e.value}`;
      case "gte":
        return `${t}${n}gte.${e.value}`;
      case "dateIs":
        return `${t}${n}eq.${l(
          e.value,
          i.ISO_DATE_FORMAT_STRING
        )}`;
      case "dateIsNot":
        return `${t}${n}not.eq.${l(
          e.value,
          i.ISO_DATE_FORMAT_STRING
        )}`;
      case "dateBefore":
        return `${t}${n}lt.${l(
          e.value,
          i.ISO_DATE_FORMAT_STRING
        )}`;
      case "dateAfter":
        return `${t}${n}gt.${l(
          e.value,
          i.ISO_DATE_FORMAT_STRING
        )}`;
    }
  }
  getGlobalConstraintSearchQuery(t, e) {
    const n = ".", r = Object.keys(t)[0], $ = Object.values(t)[0];
    if ($ === "int" && (isNaN(parseInt(e.value)) || e.value.toString().indexOf(".") > -1) || $ === "float" && isNaN(parseFloat(e.value)))
      return null;
    switch (e.matchMode) {
      case "startsWith":
      case "contains":
      case "endsWith":
      case "equals":
        return $ !== "string" ? `${r}${n}eq.${e.value}` : `${r}${n}ilike.*${e.value}*`;
      case "notContains":
      case "notEquals":
        return $ !== "string" ? `${r}${n}not.eq.${e.value}` : `${r}${n}not.ilike.*${e.value}*`;
      case "in":
        return `${r}${n}cs.{${[e.value].map((s) => `"${s}"`).join(",")}}`;
      case "lt":
        return `${r}${n}lt.${e.value}`;
      case "lte":
        return `${r}${n}lte.${e.value}`;
      case "gt":
        return `${r}${n}gt.${e.value}`;
      case "gte":
        return `${r}${n}gte.${e.value}`;
      case "dateIs":
        return `${t}${n}eq.${l(
          e.value,
          i.ISO_DATE_FORMAT_STRING
        )}`;
      case "dateIsNot":
        return `${r}${n}not.eq.${l(
          e.value,
          i.ISO_DATE_FORMAT_STRING
        )}`;
      case "dateBefore":
        return `${r}${n}lt.${l(
          e.value,
          i.ISO_DATE_FORMAT_STRING
        )}`;
      case "dateAfter":
        return `${r}${n}gt.${l(
          e.value,
          i.ISO_DATE_FORMAT_STRING
        )}`;
    }
  }
  getInternalSearchQueries(t) {
    const e = Object.entries(t).filter(([s]) => s !== d), n = e.filter(([s, o]) => O(o) ? o.constraints.filter((u) => u.value !== null).length > 0 : !1).map(([s, o]) => {
      const c = o, u = o.constraints.map((a) => this.getConstraintSearchQuery(s, a, "."));
      return `${c.operator.toLowerCase()}=(${u.join(",")})`;
    }), r = e.filter(([s, o]) => {
      const c = o;
      let u = c.value !== void 0 && c.value !== null;
      return u && Array.isArray(c.value) && (u = c.value.length > 0), u;
    }).map(([s, o]) => this.getConstraintSearchQuery(s, o));
    return [...n, ...r];
  }
  getGlobalSearchParams(t, e) {
    const n = t[d].value, r = [], $ = e.flatMap((a) => Object.keys(a)), s = Object.entries(t).filter(([a]) => a !== d && $.includes(a)).map(([a, T]) => {
      var h;
      const m = O(T) ? T : null, _ = m !== null ? (h = m.constraints[0]) == null ? void 0 : h.matchMode : T.matchMode;
      if (m !== null) {
        const g = m.constraints.filter((S) => S.value);
        if (g.length > 0) {
          for (const S of g) {
            const p = {
              value: S.value,
              matchMode: S.matchMode
            }, I = this.getConstraintSearchQuery(a, p);
            I && r.push(I);
          }
          return;
        }
      }
      const A = { value: n, matchMode: _ }, f = e.find((g) => g[a]);
      return this.getGlobalConstraintSearchQuery(f, A);
    }).filter((a) => a), o = this.getInternalSearchQueries(t), c = s.length === 0 ? [] : [`or=(${s.join(",")})`];
    return [...o, ...r, ...c].filter(
      (a) => a
    );
  }
  createSearchParams(t, e) {
    var r;
    return e ?? (e = []), ((r = t[d]) == null ? void 0 : r.value) ? this.getGlobalSearchParams(t, e) : this.getInternalSearchQueries(t);
  }
  getPaginationOptions(t) {
    const e = {
      Order: t.lazyParams.sortField,
      Sort: t.lazyParams.sortOrder > 0 ? "asc" : "desc"
    };
    return e.Offset = t.lazyParams.first ? t.lazyParams.first : 0, t.virtualScrollerOptions && t.virtualScrollerOptions.lazy === !0 && t.virtualScrollerOptions.itemSize ? e.Limit = t.virtualScrollerOptions.itemSize : t.lazyParams.rows && (e.Limit = t.lazyParams.rows), e;
  }
}
const G = new N();
export {
  P as PaginationExtensions,
  G as PrimeVueDataTableExtensions
};
