import type { PrimeVueLocaleOptions } from 'primevue/config';
import type { CountryCode } from 'vue3-flag-icons';
export declare const supportedLocales: string[];
type SupportedLocale = (typeof supportedLocales)[number];
export declare const en: {
    VALIDATIONS: {
        alpha: string;
        alphaNum: string;
        between: string;
        decimal: string;
        email: string;
        integer: string;
        ipAddress: string;
        macAddress: string;
        maxLength: string;
        maxValue: string;
        minLength: string;
        minValue: string;
        numeric: string;
        required: string;
        requiredIf: string;
        requiredUnless: string;
        sameAs: string;
        url: string;
    };
    loading: string;
    connected: string;
    disconnected: string;
    new: string;
    save: string;
    edit: string;
    delete: string;
    cancel: string;
    newest: string;
    oldest: string;
    drag_drop_files_to_upload: string;
    sort_by_arg: string;
    required_fields_label: string;
    success: string;
    failed: string;
    info: string;
    save_successful: string;
    save_failed: string;
    delete_successful: string;
    delete_failed: string;
    upload_successful: string;
    confirm_header: string;
    confirm_delete_message: string;
    confirm_delete_selected_message: string;
    copy_to_clipboard: string;
    copy_to_clipboard_success: string;
    copy_to_clipboard_failed: string;
    empty_search_message: string;
    paginate: string;
    paginator_showing: string;
    paginator_to: string;
    paginator_of: string;
    search_by: string;
    keyword_search: string;
    no_records_found: string;
    results_found: string;
    clear_filters: string;
    clear_global_filter: string;
    select_columns: string;
    columns_selected: string;
    export: string;
    selection_message: string;
    empty_selection_message: string;
};
export declare const ru: {
    VALIDATIONS: {
        alpha: string;
        alphaNum: string;
        between: string;
        decimal: string;
        email: string;
        integer: string;
        ipAddress: string;
        macAddress: string;
        maxLength: string;
        maxValue: string;
        minLength: string;
        minValue: string;
        numeric: string;
        required: string;
        requiredIf: string;
        requiredUnless: string;
        sameAs: string;
        url: string;
    };
    loading: string;
    connected: string;
    disconnected: string;
    new: string;
    save: string;
    edit: string;
    delete: string;
    cancel: string;
    newest: string;
    oldest: string;
    drag_drop_files_to_upload: string;
    sort_by_arg: string;
    required_fields_label: string;
    success: string;
    failed: string;
    info: string;
    save_successful: string;
    save_failed: string;
    delete_successful: string;
    delete_failed: string;
    upload_successful: string;
    confirm_header: string;
    confirm_delete_message: string;
    confirm_delete_selected_message: string;
    copy_to_clipboard: string;
    copy_to_clipboard_success: string;
    copy_to_clipboard_failed: string;
    empty_search_message: string;
    paginate: string;
    paginator_showing: string;
    paginator_to: string;
    paginator_of: string;
    search_by: string;
    keyword_search: string;
    no_records_found: string;
    results_found: string;
    clear_filters: string;
    clear_global_filter: string;
    select_columns: string;
    columns_selected: string;
    export: string;
    selection_message: string;
    empty_selection_message: string;
};
export declare const _i18n_internal: import("vue-i18n").I18n<{
    [x: string]: {
        VALIDATIONS: {
            alpha: string;
            alphaNum: string;
            between: string;
            decimal: string;
            email: string;
            integer: string;
            ipAddress: string;
            macAddress: string;
            maxLength: string;
            maxValue: string;
            minLength: string;
            minValue: string;
            numeric: string;
            required: string;
            requiredIf: string;
            requiredUnless: string;
            sameAs: string;
            url: string;
        };
        loading: string;
        connected: string;
        disconnected: string;
        new: string;
        save: string;
        edit: string;
        delete: string;
        cancel: string;
        newest: string;
        oldest: string;
        drag_drop_files_to_upload: string;
        sort_by_arg: string;
        required_fields_label: string;
        success: string;
        failed: string;
        info: string;
        save_successful: string;
        save_failed: string;
        delete_successful: string;
        delete_failed: string;
        upload_successful: string;
        confirm_header: string;
        confirm_delete_message: string;
        confirm_delete_selected_message: string;
        copy_to_clipboard: string;
        copy_to_clipboard_success: string;
        copy_to_clipboard_failed: string;
        empty_search_message: string;
        paginate: string;
        paginator_showing: string;
        paginator_to: string;
        paginator_of: string;
        search_by: string;
        keyword_search: string;
        no_records_found: string;
        results_found: string;
        clear_filters: string;
        clear_global_filter: string;
        select_columns: string;
        columns_selected: string;
        export: string;
        selection_message: string;
        empty_selection_message: string;
    };
}, {
    [x: string]: import("vue-i18n").IntlDateTimeFormat;
}, {
    [x: string]: import("vue-i18n").IntlNumberFormat;
}, string, true>;
export type FlagOption = {
    locale: SupportedLocale;
    languageName: string;
    countryCode: CountryCode;
};
export declare const flagOptions: FlagOption[];
export declare const primevueLocales: {
    locale: string;
    messages: PrimeVueLocaleOptions;
}[];
export {};
